#ifndef machine_info_h_included
#define machine_info_h_included


//
// Copyright 2002,2012 Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.




///@file
///
///   Defines MachineInfo -- a set of questions about os specific info.

// make sure that LINUX is defined if we are on linux

#ifndef LINUX
#ifdef __linux__

#if __linux__     // __linux__ is 1
#define LINUX 1
#else
        // __linux__ is defined but not 1?  Huh?  assume we are not linux
#endif  // __linux__ is 1
#else   // __linux__ is NOT defined
#ifdef __linux
#if __linux
#define LINUX 1
#else
        // huh?  __linux is defined but is not 1?  Assume not linux
#endif  // __linux is defined
#else
        // neither LINUX, nor __linux__, nor __linux is define, so this isn't linux
#endif  // __linux is defined
#endif  // __linux__ defined
#endif  // LINUX NOT defineed



#include <string>

namespace cxxtls
{

struct MachineInfo
  /// A description of the machine your program is running on and static
  /// methods to make inquiries.
{
   std::string operating_system_;  ///< AIX, HP-UX, SunOS, Windows, etc

   std::string hostname_;          ///< this machine's node name on the network

   static MachineInfo get();       ///< Get the MachineInfo for the current machine.
				   ///  If an error occurs, the hostname_ and
				   ///  operating_system_ names will be null. If either
				   ///  is null, an error occurred.

};

} // namespace cxxtls

#endif
